if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) 
{
	RTB_registerPref("Timeout (seconds)", "Rowboat Guy", "$RowboatGuy::Timeout", "string 50", "Player_RowboatGuy", "5", 0, 0, "");
	RTB_registerPref("Custom Color", "Rowboat Guy", "$Pref::Server::AnyColor", "bool", "Player_RowboatGuy", 1, 0, 1);
	RTB_registerPref("Cooldown Notification", "Rowboat Guy", "$Pref::Server::CDNotification", "bool", "Player_RowboatGuy", 1, 0, 1);
}
else	
{	
	$RowboatGuy::Timeout = 5;
	$RowboatGuy::AnyColor = 1;
	$RowboatGuy::CDNotification = 1;
}

package rowboatGuy
{
	function Player::onDriverLeave(%this, %obj)
	{
		parent::onDriverLeave(%this, %obj);
		if(%this.boatOwner $= %obj)
			%this.schedule(100, "delete");
	}
	
	function Armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		parent::onTrigger(%this, %obj, %triggerNum, %val);
		
		if(%triggerNum != 4 || %val || !%obj.isInWater || isObject(%obj.boat))
			return;
	
		if(%obj.getDatablock().getName() !$= "PlayerRowboatGuy")
			return;
		
		if(%obj.lastBoatSpawn + $RowboatGuy::Timeout > $Sim::Time)
		{
			if($RowboatGuy::CDNotification)
				messageClient(%obj.client, '', "\c4You must wait before spawning another boat.");
			return;
		}
		
		%obj.boat = new AIPlayer()
		{
			datablock = RowBoatArmor;
			position = %obj.getPosition();
			boatOwner = %obj;
		};
		
		if($RowboatGuy::AnyColor)
		{
			%color = %obj.client.currentColor;
			if(%color !$= "")
				%color = getColorIDTable(%color);
			else
				%color = "0.392157 0.196078 0 1";
		}
		else
			%color = "0.392157 0.196078 0 1";
		
		%obj.boat.setTempColor(%color);
		missionCleanup.add(%obj.boat);
		%obj.boat.schedule(100, "mountObject", %obj, 0);
		%obj.lastBoatSpawn = $Sim::Time;
	}
};
activatePackage(rowboatGuy);

function PlayerRowboatGuy::onEnterLiquid(%this, %obj, %coverage, %type)
{
	%obj.isInWater = 1;
}

function PlayerRowboatGuy::onLeaveLiquid(%this, %obj, %coverage, %type)
{
	%obj.isInWater = 0;
}

datablock PlayerData(PlayerRowboatGuy : PlayerStandardArmor)
{
	canJet = 0;
	uiName = "Rowboat Guy";
};
